# 01-Central-limit-U.py.     I. Marti-Vidal.      IMPRS Blackboard Lectures 2011.
# LET US PLAY WITH THE CENTRAL-LIMIT THEOREM.

import numpy as np
import pylab as pl
import random 

# Parameters:
nmonte = 5000  # Size of the original dataset (i.e., our "universe" of measurements).
nsample = 100  # Size of each subset of data that will be averaged.
niter =  5000  # Number of averages to perform (i.e., # of random subsets to average).
bins = 30      # Number of bins in the plotted histograms. 

# Create data:
origdata = np.random.uniform(0,1,nmonte)  # Uniform distribution

# Loop to select random samples from the data and average each sample:
averdata=[]
for i in range(niter):
 selecdata = random.sample(origdata,nsample)  # A random sample of length nsample.
 averdata.append(np.average(selecdata)) # Add the average of the sample to our vector of averages.

# Print some results:
print "Av. and std. of the original distribution: ",np.average(origdata)," +/- ",np.std(origdata)
print "Av. and std. of the averages:              ",np.average(averdata)," +/- ",np.std(averdata)
print "Number of samples in each average:         ",nsample

# Plot results:

pl.figure()
pl.hist(origdata,bins)
pl.title("Distribution of original data")

pl.figure()
pl.hist(averdata,bins)
pl.title("Distribution of average of random samples")

pl.show()

