# 02-Central-limit-SQRT.py.     I. Marti-Vidal.      IMPRS Blackboard Lectures 2011.

import numpy as np
import pylab as pl
import random

# Parameters:
nmonte =  5000
nsample =  100
niter  =  5000
bins = 30

# Create data:
origdata = np.sqrt(np.random.uniform(0,1,nmonte))  # Now the distribution is sqrt(U)

# Loop to select random samples from the data and average each sample:
averdata=[]
for i in range(niter):
 selecdata = random.sample(origdata,nsample)
 averdata.append(np.average(selecdata))


# Print some results:
print "Av. and std. of the original distribution: ",np.average(origdata)," +/- ",np.std(origdata)
print "Av. and std. of the averages:              ",np.average(averdata)," +/- ",np.std(averdata)
print "Number of samples in each average:         ",nsample


# Plot results:

pl.hist(origdata,bins)
pl.title("Distribution of original data")

pl.figure()
pl.hist(averdata,bins)
pl.title("Distribution of averages of random samples")

pl.show()

