# Error-of-the-error.py.     I. Marti-Vidal.      IMPRS Blackboard Lectures 2011.
# DISTRIBUTE THE SUM OF SQUARES OF SAMPLES TAKEN FROM A NORMAL DISTRIBUTION.

import numpy as np
import pylab as pl
import random

# Parameters:
nmonte = 10000
nsample =  100
niter  =  1000
bins =      30

# Create data (following a normal distribution):
origdata = np.random.normal(0,1,nmonte)

averdata=[]
sumofsquares=[]

# Select random samples from the data and compute the sum of squares:
for i in range(niter):
 selecdata = random.sample(origdata,nsample)
 sumofsquares.append(nsample*np.var(selecdata)) # SOQ = N*VARIANCE

# Print out some interesting results:
avsoq = np.average(sumofsquares)
print "\nAverage sum of squares: ", avsoq
print "Expected sum of squares: ",nsample-1
print "Std of the sum of squares: ", np.std(sumofsquares)
print "sqrt(2*Av(soq)) = ",np.sqrt(2.*avsoq)

# Plot results:

pl.figure()
pl.hist(origdata,bins)
pl.title("Distribution of original data")

pl.figure()
pl.hist(sumofsquares,bins)
pl.title("Distribution of the sums of squares")


pl.show()

